/* 
    kleds for KDE2

    Copyright (C) 2001 Hans Matzen (hans@hansmatzen.de)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#include "prefs.h"

#include <kcolorbutton.h>
#include <qcombobox.h>
#include <qgroupbox.h>
#include <qlabel.h>
#include <qpushbutton.h>
#include <klocale.h>

Prefs::Prefs( QWidget* parent, const char* name, bool modal, WFlags fl )
    : QDialog( parent, name, modal, fl )
{
    if ( !name )
	setName( "KLeds Preferences" );
    resize( 360, 350 ); 
    setCaption( I18N_NOOP("KLeds Preferences") );

    // all labels
    TextLabel1 = new QLabel( this, "TextLabel1" );
    TextLabel1->setGeometry( QRect( 20, 10, 120, 20 ) ); 
    TextLabel1->setText( I18N_NOOP("KLeds Preferences:") );
  
    GroupBox1 = new QGroupBox( this, "GroupBox1" );
    GroupBox1->setGeometry( QRect( 20, 40, 320, 240 ) ); 
    GroupBox1->setTitle( I18N_NOOP( "Layout:" ) );

    TextLabel2_2 = new QLabel( GroupBox1, "TextLabel2_2" );
    TextLabel2_2->setGeometry( QRect( 10, 40, 80, 20 ) ); 
    TextLabel2_2->setText( I18N_NOOP( "Num - LED:" ) );

    TextLabel2_2_2 = new QLabel( GroupBox1, "TextLabel2_2_2" );
    TextLabel2_2_2->setGeometry( QRect( 10, 70, 80, 20 ) ); 
    TextLabel2_2_2->setText( I18N_NOOP( "Caps - LED:" ) );

    TextLabel2_2_2_2 = new QLabel( GroupBox1, "TextLabel2_2_2_2" );
    TextLabel2_2_2_2->setGeometry( QRect( 10, 100, 80, 20 ) ); 
    TextLabel2_2_2_2->setText( I18N_NOOP( "Scroll - LED:" ) );

    TextLabel2 = new QLabel( GroupBox1, "TextLabel2" );
    TextLabel2->setGeometry( QRect( 10, 150, 100, 20 ) ); 
    TextLabel2->setText( I18N_NOOP( "Label Position:" ) );

    // all for num led
    ComboBox1_2 = new QComboBox( FALSE, GroupBox1, "ComboBox1_2" );
    ComboBox1_2->insertItem( I18N_NOOP( "circular" ) );
    ComboBox1_2->insertItem( I18N_NOOP( "rectangular" ) );
    ComboBox1_2->setGeometry( QRect( 100, 40, 88, 22 ) ); 

    KColorButton1 = new KColorButton( GroupBox1, "KColorButton1" );
    KColorButton1->setGeometry( QRect( 200, 40, 80, 20 ) ); 

    // all for caps led
    ComboBox1_2_2_2 = new QComboBox( FALSE, GroupBox1, "ComboBox1_2_2_2" );
    ComboBox1_2_2_2->insertItem( I18N_NOOP( "circular" ) );
    ComboBox1_2_2_2->insertItem( I18N_NOOP( "rectangular" ) );
    ComboBox1_2_2_2->setGeometry( QRect( 100, 70, 88, 22 ) ); 
    
    KColorButton1_2 = new KColorButton( GroupBox1, "KColorButton1_2" );
    KColorButton1_2->setGeometry( QRect( 200, 70, 80, 20 ) ); 

    // all for scroll led
    ComboBox1_2_2 = new QComboBox( FALSE, GroupBox1, "ComboBox1_2_2" );
    ComboBox1_2_2->insertItem( I18N_NOOP( "circular" ) );
    ComboBox1_2_2->insertItem( I18N_NOOP( "rectangular" ) );
    ComboBox1_2_2->setGeometry( QRect( 100, 100, 88, 22 ) ); 

    KColorButton1_3 = new KColorButton( GroupBox1, "KColorButton1_3" );
    KColorButton1_3->setGeometry( QRect( 200, 100, 80, 20 ) ); 

    // the label position widget
    ComboBox1 = new QComboBox( FALSE, GroupBox1, "ComboBox1" );
    ComboBox1->insertItem( I18N_NOOP( "Left" ) );
    ComboBox1->insertItem( I18N_NOOP( "Right" ) );
    ComboBox1->insertItem( I18N_NOOP( "Top" ) );
    ComboBox1->insertItem( I18N_NOOP( "Bottom" ) );
    ComboBox1->setGeometry( QRect( 100, 150, 88, 22 ) ); 

    // the okay and cancel buttons
    PushButton1 = new QPushButton( this, "PushButton1" );
    PushButton1->setGeometry( QRect( 20, 300, 102, 26 ) ); 
    PushButton1->setText( I18N_NOOP( "Ok" ) );

    PushButton1_3 = new QPushButton( this, "PushButton1_3" );
    PushButton1_3->setGeometry( QRect( 240, 300, 102, 26 ) ); 
    PushButton1_3->setText( I18N_NOOP( "Cancel" ) );

    // signals and slots connections
    connect( PushButton1, SIGNAL( clicked() ), this, SLOT( accept() ) );
    connect( PushButton1_3, SIGNAL( clicked() ), this, SLOT( reject() ) );

}

// destructor
Prefs::~Prefs(){}

void Prefs::cancel()
{
    this->reject();
}

void Prefs::ok()
{
    this->accept();
}


 /* methods for setting and getting the widget values */
KLed::Shape Prefs::get_num_shape()
{
    if (ComboBox1_2->currentText()==QString("circular"))
	return KLed::Circular;
    else
	return KLed::Rectangular;
}

KLed::Shape Prefs::get_caps_shape()
{ 
    if (ComboBox1_2_2_2->currentText()==QString("circular"))
	return KLed::Circular;
    else
	return KLed::Rectangular;
}

KLed::Shape Prefs::get_scroll_shape()
{ 
    if (ComboBox1_2_2->currentText()==QString("circular"))
	return KLed::Circular;
    else
	return KLed::Rectangular;
}

QColor Prefs::get_num_color()
{
    return KColorButton1->color();
}

QColor Prefs::get_caps_color()
{
    return KColorButton1_2->color();
}

QColor Prefs::get_scroll_color()
{
    return KColorButton1_3->color();
}

uint Prefs::get_label_position()
{ 
    switch (ComboBox1->currentItem()) {
	case 0:
	    return LEFT;
	    break;
	case 1:
	    return RIGHT;
	    break;
	case 2:
	    return TOP;
	    break;
	case 3:
	    return BOTTOM;
	    break;
   }
    return 0;
}

void Prefs::set_num_shape(KLed::Shape shape)
{
    if (shape==1)
	ComboBox1_2->setCurrentItem(0);
    else
	ComboBox1_2->setCurrentItem(1);
}

void Prefs::set_scroll_shape(KLed::Shape shape)
{  
    if (shape==1)
	ComboBox1_2_2->setCurrentItem(0);
    else
	ComboBox1_2_2->setCurrentItem(1);
}

void Prefs::set_caps_shape(KLed::Shape shape)
{  
    if (shape==1)
	ComboBox1_2_2_2->setCurrentItem(0);
    else
	ComboBox1_2_2_2->setCurrentItem(1);
}

void Prefs::set_num_color(QColor col)
{
    KColorButton1->setColor(col);
}

void Prefs::set_caps_color(QColor col)
{
    KColorButton1_2->setColor(col);
}

void Prefs::set_scroll_color(QColor col)
{
    KColorButton1_3->setColor(col);
}

void Prefs::set_label_position(uint labpos)
{
    ComboBox1->setCurrentItem(labpos);
}
